from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class OrderByDirection(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    order_by_direction_ascending: _ClassVar[OrderByDirection]
    order_by_direction_descending: _ClassVar[OrderByDirection]
order_by_direction_ascending: OrderByDirection
order_by_direction_descending: OrderByDirection

class Uuid(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class PhoneNumber(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class EmailAddress(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class PostalCode(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class CountryCode(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class PlaceAddress(_message.Message):
    __slots__ = ("street", "city", "state_or_province", "postal_code", "country_code")
    STREET_FIELD_NUMBER: _ClassVar[int]
    CITY_FIELD_NUMBER: _ClassVar[int]
    STATE_OR_PROVINCE_FIELD_NUMBER: _ClassVar[int]
    POSTAL_CODE_FIELD_NUMBER: _ClassVar[int]
    COUNTRY_CODE_FIELD_NUMBER: _ClassVar[int]
    street: _containers.RepeatedScalarFieldContainer[str]
    city: str
    state_or_province: str
    postal_code: PostalCode
    country_code: CountryCode
    def __init__(self, street: _Optional[_Iterable[str]] = ..., city: _Optional[str] = ..., state_or_province: _Optional[str] = ..., postal_code: _Optional[_Union[PostalCode, _Mapping]] = ..., country_code: _Optional[_Union[CountryCode, _Mapping]] = ...) -> None: ...

class CompanyRegistrationNumber(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class VatIdentificationNumber(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class AuthInfo(_message.Message):
    __slots__ = ("password",)
    PASSWORD_FIELD_NUMBER: _ClassVar[int]
    password: str
    def __init__(self, password: _Optional[str] = ...) -> None: ...

class StateFlag(_message.Message):
    __slots__ = ()
    class Manipulation(_message.Message):
        __slots__ = ()
        class Enum(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = ()
            manual: _ClassVar[StateFlag.Manipulation.Enum]
            automatic: _ClassVar[StateFlag.Manipulation.Enum]
        manual: StateFlag.Manipulation.Enum
        automatic: StateFlag.Manipulation.Enum
        def __init__(self) -> None: ...
    class Visibility(_message.Message):
        __slots__ = ()
        class Enum(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
            __slots__ = ()
            external: _ClassVar[StateFlag.Visibility.Enum]
            internal: _ClassVar[StateFlag.Visibility.Enum]
        external: StateFlag.Visibility.Enum
        internal: StateFlag.Visibility.Enum
        def __init__(self) -> None: ...
    class Traits(_message.Message):
        __slots__ = ("how_to_set", "visibility")
        HOW_TO_SET_FIELD_NUMBER: _ClassVar[int]
        VISIBILITY_FIELD_NUMBER: _ClassVar[int]
        how_to_set: StateFlag.Manipulation.Enum
        visibility: StateFlag.Visibility.Enum
        def __init__(self, how_to_set: _Optional[_Union[StateFlag.Manipulation.Enum, str]] = ..., visibility: _Optional[_Union[StateFlag.Visibility.Enum, str]] = ...) -> None: ...
    def __init__(self) -> None: ...

class Url(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class LogEntryId(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class FileId(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class InvalidData(_message.Message):
    __slots__ = ("fields",)
    FIELDS_FIELD_NUMBER: _ClassVar[int]
    fields: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...

class ContactDoesNotExist(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class DomainDoesNotExist(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class KeysetDoesNotExist(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class NssetDoesNotExist(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class RegistrarDoesNotExist(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...
