from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ContactAlreadyExists(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class ContactHandleInProtectionPeriod(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class CreateContactRequest(_message.Message):
    __slots__ = ("contact_handle", "name", "organization", "place", "telephone", "fax", "emails", "notify_emails", "vat_identification_number", "additional_identifier", "disclose", "mailing_address", "billing_address", "shipping_address1", "shipping_address2", "shipping_address3", "warning_letter", "log_entry_id", "by_registrar")
    class DiscloseEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: bool
        def __init__(self, key: _Optional[str] = ..., value: bool = ...) -> None: ...
    CONTACT_HANDLE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    ORGANIZATION_FIELD_NUMBER: _ClassVar[int]
    PLACE_FIELD_NUMBER: _ClassVar[int]
    TELEPHONE_FIELD_NUMBER: _ClassVar[int]
    FAX_FIELD_NUMBER: _ClassVar[int]
    EMAILS_FIELD_NUMBER: _ClassVar[int]
    NOTIFY_EMAILS_FIELD_NUMBER: _ClassVar[int]
    VAT_IDENTIFICATION_NUMBER_FIELD_NUMBER: _ClassVar[int]
    ADDITIONAL_IDENTIFIER_FIELD_NUMBER: _ClassVar[int]
    DISCLOSE_FIELD_NUMBER: _ClassVar[int]
    MAILING_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    BILLING_ADDRESS_FIELD_NUMBER: _ClassVar[int]
    SHIPPING_ADDRESS1_FIELD_NUMBER: _ClassVar[int]
    SHIPPING_ADDRESS2_FIELD_NUMBER: _ClassVar[int]
    SHIPPING_ADDRESS3_FIELD_NUMBER: _ClassVar[int]
    WARNING_LETTER_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    BY_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
    contact_handle: _contact_common_types_pb2.ContactHandle
    name: str
    organization: str
    place: _common_types_pb2.PlaceAddress
    telephone: _common_types_pb2.PhoneNumber
    fax: _common_types_pb2.PhoneNumber
    emails: _containers.RepeatedCompositeFieldContainer[_common_types_pb2.EmailAddress]
    notify_emails: _containers.RepeatedCompositeFieldContainer[_common_types_pb2.EmailAddress]
    vat_identification_number: _common_types_pb2.VatIdentificationNumber
    additional_identifier: _contact_common_types_pb2.ContactAdditionalIdentifier
    disclose: _containers.ScalarMap[str, bool]
    mailing_address: _contact_common_types_pb2.ContactAddress
    billing_address: _contact_common_types_pb2.ContactAddress
    shipping_address1: _contact_common_types_pb2.ContactAddress
    shipping_address2: _contact_common_types_pb2.ContactAddress
    shipping_address3: _contact_common_types_pb2.ContactAddress
    warning_letter: _contact_common_types_pb2.WarningLetter
    log_entry_id: _common_types_pb2.LogEntryId
    by_registrar: _registrar_common_types_pb2.RegistrarHandle
    def __init__(self, contact_handle: _Optional[_Union[_contact_common_types_pb2.ContactHandle, _Mapping]] = ..., name: _Optional[str] = ..., organization: _Optional[str] = ..., place: _Optional[_Union[_common_types_pb2.PlaceAddress, _Mapping]] = ..., telephone: _Optional[_Union[_common_types_pb2.PhoneNumber, _Mapping]] = ..., fax: _Optional[_Union[_common_types_pb2.PhoneNumber, _Mapping]] = ..., emails: _Optional[_Iterable[_Union[_common_types_pb2.EmailAddress, _Mapping]]] = ..., notify_emails: _Optional[_Iterable[_Union[_common_types_pb2.EmailAddress, _Mapping]]] = ..., vat_identification_number: _Optional[_Union[_common_types_pb2.VatIdentificationNumber, _Mapping]] = ..., additional_identifier: _Optional[_Union[_contact_common_types_pb2.ContactAdditionalIdentifier, _Mapping]] = ..., disclose: _Optional[_Mapping[str, bool]] = ..., mailing_address: _Optional[_Union[_contact_common_types_pb2.ContactAddress, _Mapping]] = ..., billing_address: _Optional[_Union[_contact_common_types_pb2.ContactAddress, _Mapping]] = ..., shipping_address1: _Optional[_Union[_contact_common_types_pb2.ContactAddress, _Mapping]] = ..., shipping_address2: _Optional[_Union[_contact_common_types_pb2.ContactAddress, _Mapping]] = ..., shipping_address3: _Optional[_Union[_contact_common_types_pb2.ContactAddress, _Mapping]] = ..., warning_letter: _Optional[_Union[_contact_common_types_pb2.WarningLetter, _Mapping]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ..., by_registrar: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ...) -> None: ...

class CreateContactReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("contact_id",)
        CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
        contact_id: _contact_common_types_pb2.ContactId
        def __init__(self, contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("invalid_data", "contact_already_exists", "contact_handle_in_protection_period", "registrar_does_not_exist")
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        CONTACT_ALREADY_EXISTS_FIELD_NUMBER: _ClassVar[int]
        CONTACT_HANDLE_IN_PROTECTION_PERIOD_FIELD_NUMBER: _ClassVar[int]
        REGISTRAR_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        invalid_data: _common_types_pb2.InvalidData
        contact_already_exists: ContactAlreadyExists
        contact_handle_in_protection_period: ContactHandleInProtectionPeriod
        registrar_does_not_exist: _common_types_pb2.RegistrarDoesNotExist
        def __init__(self, invalid_data: _Optional[_Union[_common_types_pb2.InvalidData, _Mapping]] = ..., contact_already_exists: _Optional[_Union[ContactAlreadyExists, _Mapping]] = ..., contact_handle_in_protection_period: _Optional[_Union[ContactHandleInProtectionPeriod, _Mapping]] = ..., registrar_does_not_exist: _Optional[_Union[_common_types_pb2.RegistrarDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: CreateContactReply.Data
    exception: CreateContactReply.Exception
    def __init__(self, data: _Optional[_Union[CreateContactReply.Data, _Mapping]] = ..., exception: _Optional[_Union[CreateContactReply.Exception, _Mapping]] = ...) -> None: ...
