from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry.keyset import keyset_common_types_pb2 as _keyset_common_types_pb2
from fred_api.registry import pagination_pb2 as _pagination_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ListDomainsByKeysetRequest(_message.Message):
    __slots__ = ("keyset_id", "pagination", "order_by", "aggregate_entire_history")
    class OrderByField(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        order_by_field_unspecified: _ClassVar[ListDomainsByKeysetRequest.OrderByField]
        order_by_field_crdate: _ClassVar[ListDomainsByKeysetRequest.OrderByField]
        order_by_field_exdate: _ClassVar[ListDomainsByKeysetRequest.OrderByField]
        order_by_field_fqdn: _ClassVar[ListDomainsByKeysetRequest.OrderByField]
        order_by_field_sponsoring_registrar_handle: _ClassVar[ListDomainsByKeysetRequest.OrderByField]
    order_by_field_unspecified: ListDomainsByKeysetRequest.OrderByField
    order_by_field_crdate: ListDomainsByKeysetRequest.OrderByField
    order_by_field_exdate: ListDomainsByKeysetRequest.OrderByField
    order_by_field_fqdn: ListDomainsByKeysetRequest.OrderByField
    order_by_field_sponsoring_registrar_handle: ListDomainsByKeysetRequest.OrderByField
    class OrderBy(_message.Message):
        __slots__ = ("field", "direction")
        FIELD_FIELD_NUMBER: _ClassVar[int]
        DIRECTION_FIELD_NUMBER: _ClassVar[int]
        field: ListDomainsByKeysetRequest.OrderByField
        direction: _common_types_pb2.OrderByDirection
        def __init__(self, field: _Optional[_Union[ListDomainsByKeysetRequest.OrderByField, str]] = ..., direction: _Optional[_Union[_common_types_pb2.OrderByDirection, str]] = ...) -> None: ...
    KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
    PAGINATION_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    AGGREGATE_ENTIRE_HISTORY_FIELD_NUMBER: _ClassVar[int]
    keyset_id: _keyset_common_types_pb2.KeysetId
    pagination: _pagination_pb2.PaginationRequest
    order_by: _containers.RepeatedCompositeFieldContainer[ListDomainsByKeysetRequest.OrderBy]
    aggregate_entire_history: bool
    def __init__(self, keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationRequest, _Mapping]] = ..., order_by: _Optional[_Iterable[_Union[ListDomainsByKeysetRequest.OrderBy, _Mapping]]] = ..., aggregate_entire_history: bool = ...) -> None: ...

class ListDomainsByKeysetReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("domains", "pagination")
        class Domain(_message.Message):
            __slots__ = ("domain", "domain_history_id", "is_deleted")
            DOMAIN_FIELD_NUMBER: _ClassVar[int]
            DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
            IS_DELETED_FIELD_NUMBER: _ClassVar[int]
            domain: _domain_common_types_pb2.DomainRef
            domain_history_id: _domain_common_types_pb2.DomainHistoryId
            is_deleted: bool
            def __init__(self, domain: _Optional[_Union[_domain_common_types_pb2.DomainRef, _Mapping]] = ..., domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ..., is_deleted: bool = ...) -> None: ...
        DOMAINS_FIELD_NUMBER: _ClassVar[int]
        PAGINATION_FIELD_NUMBER: _ClassVar[int]
        domains: _containers.RepeatedCompositeFieldContainer[ListDomainsByKeysetReply.Data.Domain]
        pagination: _pagination_pb2.PaginationReply
        def __init__(self, domains: _Optional[_Iterable[_Union[ListDomainsByKeysetReply.Data.Domain, _Mapping]]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationReply, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("keyset_does_not_exist", "invalid_data")
        KEYSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        keyset_does_not_exist: _common_types_pb2.KeysetDoesNotExist
        invalid_data: _common_types_pb2.InvalidData
        def __init__(self, keyset_does_not_exist: _Optional[_Union[_common_types_pb2.KeysetDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[_common_types_pb2.InvalidData, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: ListDomainsByKeysetReply.Data
    exception: ListDomainsByKeysetReply.Exception
    def __init__(self, data: _Optional[_Union[ListDomainsByKeysetReply.Data, _Mapping]] = ..., exception: _Optional[_Union[ListDomainsByKeysetReply.Exception, _Mapping]] = ...) -> None: ...
