from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry.nsset import nsset_common_types_pb2 as _nsset_common_types_pb2
from fred_api.registry import pagination_pb2 as _pagination_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class NssetDoesNotExist(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class ListDomainsByNssetRequest(_message.Message):
    __slots__ = ("nsset_id", "pagination", "order_by", "aggregate_entire_history")
    class OrderByField(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        order_by_field_unspecified: _ClassVar[ListDomainsByNssetRequest.OrderByField]
        order_by_field_crdate: _ClassVar[ListDomainsByNssetRequest.OrderByField]
        order_by_field_exdate: _ClassVar[ListDomainsByNssetRequest.OrderByField]
        order_by_field_fqdn: _ClassVar[ListDomainsByNssetRequest.OrderByField]
        order_by_field_sponsoring_registrar_handle: _ClassVar[ListDomainsByNssetRequest.OrderByField]
    order_by_field_unspecified: ListDomainsByNssetRequest.OrderByField
    order_by_field_crdate: ListDomainsByNssetRequest.OrderByField
    order_by_field_exdate: ListDomainsByNssetRequest.OrderByField
    order_by_field_fqdn: ListDomainsByNssetRequest.OrderByField
    order_by_field_sponsoring_registrar_handle: ListDomainsByNssetRequest.OrderByField
    class OrderBy(_message.Message):
        __slots__ = ("field", "direction")
        FIELD_FIELD_NUMBER: _ClassVar[int]
        DIRECTION_FIELD_NUMBER: _ClassVar[int]
        field: ListDomainsByNssetRequest.OrderByField
        direction: _common_types_pb2.OrderByDirection
        def __init__(self, field: _Optional[_Union[ListDomainsByNssetRequest.OrderByField, str]] = ..., direction: _Optional[_Union[_common_types_pb2.OrderByDirection, str]] = ...) -> None: ...
    NSSET_ID_FIELD_NUMBER: _ClassVar[int]
    PAGINATION_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    AGGREGATE_ENTIRE_HISTORY_FIELD_NUMBER: _ClassVar[int]
    nsset_id: _nsset_common_types_pb2.NssetId
    pagination: _pagination_pb2.PaginationRequest
    order_by: _containers.RepeatedCompositeFieldContainer[ListDomainsByNssetRequest.OrderBy]
    aggregate_entire_history: bool
    def __init__(self, nsset_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationRequest, _Mapping]] = ..., order_by: _Optional[_Iterable[_Union[ListDomainsByNssetRequest.OrderBy, _Mapping]]] = ..., aggregate_entire_history: bool = ...) -> None: ...

class ListDomainsByNssetReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("deprecated_domains", "domains", "pagination")
        class Domain(_message.Message):
            __slots__ = ("domain", "domain_history_id", "is_deleted")
            DOMAIN_FIELD_NUMBER: _ClassVar[int]
            DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
            IS_DELETED_FIELD_NUMBER: _ClassVar[int]
            domain: _domain_common_types_pb2.DomainRef
            domain_history_id: _domain_common_types_pb2.DomainHistoryId
            is_deleted: bool
            def __init__(self, domain: _Optional[_Union[_domain_common_types_pb2.DomainRef, _Mapping]] = ..., domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ..., is_deleted: bool = ...) -> None: ...
        DEPRECATED_DOMAINS_FIELD_NUMBER: _ClassVar[int]
        DOMAINS_FIELD_NUMBER: _ClassVar[int]
        PAGINATION_FIELD_NUMBER: _ClassVar[int]
        deprecated_domains: _containers.RepeatedCompositeFieldContainer[_domain_common_types_pb2.DomainRef]
        domains: _containers.RepeatedCompositeFieldContainer[ListDomainsByNssetReply.Data.Domain]
        pagination: _pagination_pb2.PaginationReply
        def __init__(self, deprecated_domains: _Optional[_Iterable[_Union[_domain_common_types_pb2.DomainRef, _Mapping]]] = ..., domains: _Optional[_Iterable[_Union[ListDomainsByNssetReply.Data.Domain, _Mapping]]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationReply, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("nsset_does_not_exist", "invalid_data")
        NSSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        nsset_does_not_exist: NssetDoesNotExist
        invalid_data: _common_types_pb2.InvalidData
        def __init__(self, nsset_does_not_exist: _Optional[_Union[NssetDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[_common_types_pb2.InvalidData, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: ListDomainsByNssetReply.Data
    exception: ListDomainsByNssetReply.Exception
    def __init__(self, data: _Optional[_Union[ListDomainsByNssetReply.Data, _Mapping]] = ..., exception: _Optional[_Union[ListDomainsByNssetReply.Exception, _Mapping]] = ...) -> None: ...
