from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry.keyset import keyset_common_types_pb2 as _keyset_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import object_events_pb2 as _object_events_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class KeysetInfoRequest(_message.Message):
    __slots__ = ("keyset_id", "keyset_history_id", "include_domains_count")
    KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
    KEYSET_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_DOMAINS_COUNT_FIELD_NUMBER: _ClassVar[int]
    keyset_id: _keyset_common_types_pb2.KeysetId
    keyset_history_id: _keyset_common_types_pb2.KeysetHistoryId
    include_domains_count: bool
    def __init__(self, keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., keyset_history_id: _Optional[_Union[_keyset_common_types_pb2.KeysetHistoryId, _Mapping]] = ..., include_domains_count: bool = ...) -> None: ...

class DnsKey(_message.Message):
    __slots__ = ("flags", "protocol", "alg", "key")
    FLAGS_FIELD_NUMBER: _ClassVar[int]
    PROTOCOL_FIELD_NUMBER: _ClassVar[int]
    ALG_FIELD_NUMBER: _ClassVar[int]
    KEY_FIELD_NUMBER: _ClassVar[int]
    flags: int
    protocol: int
    alg: int
    key: str
    def __init__(self, flags: _Optional[int] = ..., protocol: _Optional[int] = ..., alg: _Optional[int] = ..., key: _Optional[str] = ...) -> None: ...

class KeysetInfoReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("keyset_handle", "keyset_id", "keyset_history_id", "dns_keys", "technical_contacts_old", "technical_contacts", "events", "sponsoring_registrar", "domains_count")
        KEYSET_HANDLE_FIELD_NUMBER: _ClassVar[int]
        KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
        KEYSET_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        DNS_KEYS_FIELD_NUMBER: _ClassVar[int]
        TECHNICAL_CONTACTS_OLD_FIELD_NUMBER: _ClassVar[int]
        TECHNICAL_CONTACTS_FIELD_NUMBER: _ClassVar[int]
        EVENTS_FIELD_NUMBER: _ClassVar[int]
        SPONSORING_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
        DOMAINS_COUNT_FIELD_NUMBER: _ClassVar[int]
        keyset_handle: _keyset_common_types_pb2.KeysetHandle
        keyset_id: _keyset_common_types_pb2.KeysetId
        keyset_history_id: _keyset_common_types_pb2.KeysetHistoryId
        dns_keys: _containers.RepeatedCompositeFieldContainer[DnsKey]
        technical_contacts_old: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactId]
        technical_contacts: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactRef]
        events: _object_events_pb2.ObjectEvents
        sponsoring_registrar: _registrar_common_types_pb2.RegistrarHandle
        domains_count: int
        def __init__(self, keyset_handle: _Optional[_Union[_keyset_common_types_pb2.KeysetHandle, _Mapping]] = ..., keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., keyset_history_id: _Optional[_Union[_keyset_common_types_pb2.KeysetHistoryId, _Mapping]] = ..., dns_keys: _Optional[_Iterable[_Union[DnsKey, _Mapping]]] = ..., technical_contacts_old: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactId, _Mapping]]] = ..., technical_contacts: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactRef, _Mapping]]] = ..., events: _Optional[_Union[_object_events_pb2.ObjectEvents, _Mapping]] = ..., sponsoring_registrar: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., domains_count: _Optional[int] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("keyset_does_not_exist", "invalid_data")
        KEYSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        keyset_does_not_exist: _common_types_pb2.KeysetDoesNotExist
        invalid_data: _common_types_pb2.InvalidData
        def __init__(self, keyset_does_not_exist: _Optional[_Union[_common_types_pb2.KeysetDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[_common_types_pb2.InvalidData, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: KeysetInfoReply.Data
    exception: KeysetInfoReply.Exception
    def __init__(self, data: _Optional[_Union[KeysetInfoReply.Data, _Mapping]] = ..., exception: _Optional[_Union[KeysetInfoReply.Exception, _Mapping]] = ...) -> None: ...

class BatchKeysetInfoRequest(_message.Message):
    __slots__ = ("requests",)
    REQUESTS_FIELD_NUMBER: _ClassVar[int]
    requests: _containers.RepeatedCompositeFieldContainer[KeysetInfoRequest]
    def __init__(self, requests: _Optional[_Iterable[_Union[KeysetInfoRequest, _Mapping]]] = ...) -> None: ...

class BatchKeysetInfoReply(_message.Message):
    __slots__ = ("data",)
    class Data(_message.Message):
        __slots__ = ("replies",)
        class BatchReply(_message.Message):
            __slots__ = ("data", "error")
            DATA_FIELD_NUMBER: _ClassVar[int]
            ERROR_FIELD_NUMBER: _ClassVar[int]
            data: KeysetInfoReply.Data
            error: BatchKeysetInfoReply.Error
            def __init__(self, data: _Optional[_Union[KeysetInfoReply.Data, _Mapping]] = ..., error: _Optional[_Union[BatchKeysetInfoReply.Error, _Mapping]] = ...) -> None: ...
        REPLIES_FIELD_NUMBER: _ClassVar[int]
        replies: _containers.RepeatedCompositeFieldContainer[BatchKeysetInfoReply.Data.BatchReply]
        def __init__(self, replies: _Optional[_Iterable[_Union[BatchKeysetInfoReply.Data.BatchReply, _Mapping]]] = ...) -> None: ...
    class Error(_message.Message):
        __slots__ = ("request", "exception")
        REQUEST_FIELD_NUMBER: _ClassVar[int]
        EXCEPTION_FIELD_NUMBER: _ClassVar[int]
        request: KeysetInfoRequest
        exception: KeysetInfoReply.Exception
        def __init__(self, request: _Optional[_Union[KeysetInfoRequest, _Mapping]] = ..., exception: _Optional[_Union[KeysetInfoReply.Exception, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: BatchKeysetInfoReply.Data
    def __init__(self, data: _Optional[_Union[BatchKeysetInfoReply.Data, _Mapping]] = ...) -> None: ...

class KeysetIdRequest(_message.Message):
    __slots__ = ("keyset_handle",)
    KEYSET_HANDLE_FIELD_NUMBER: _ClassVar[int]
    keyset_handle: _keyset_common_types_pb2.KeysetHandle
    def __init__(self, keyset_handle: _Optional[_Union[_keyset_common_types_pb2.KeysetHandle, _Mapping]] = ...) -> None: ...

class KeysetIdReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("keyset_id", "keyset_history_id")
        KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
        KEYSET_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        keyset_id: _keyset_common_types_pb2.KeysetId
        keyset_history_id: _keyset_common_types_pb2.KeysetHistoryId
        def __init__(self, keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., keyset_history_id: _Optional[_Union[_keyset_common_types_pb2.KeysetHistoryId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("keyset_does_not_exist",)
        class KeysetDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        KEYSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        keyset_does_not_exist: KeysetIdReply.Exception.KeysetDoesNotExist
        def __init__(self, keyset_does_not_exist: _Optional[_Union[KeysetIdReply.Exception.KeysetDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: KeysetIdReply.Data
    exception: KeysetIdReply.Exception
    def __init__(self, data: _Optional[_Union[KeysetIdReply.Data, _Mapping]] = ..., exception: _Optional[_Union[KeysetIdReply.Exception, _Mapping]] = ...) -> None: ...
