from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class CreateRegistrarRequest(_message.Message):
    __slots__ = ("registrar_handle", "name", "organization", "place", "telephone", "fax", "emails", "url", "is_system_registrar", "company_registration_number", "vat_identification_number", "variable_symbol", "payment_memo_regex", "is_vat_payer", "is_internal")
    REGISTRAR_HANDLE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    ORGANIZATION_FIELD_NUMBER: _ClassVar[int]
    PLACE_FIELD_NUMBER: _ClassVar[int]
    TELEPHONE_FIELD_NUMBER: _ClassVar[int]
    FAX_FIELD_NUMBER: _ClassVar[int]
    EMAILS_FIELD_NUMBER: _ClassVar[int]
    URL_FIELD_NUMBER: _ClassVar[int]
    IS_SYSTEM_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
    COMPANY_REGISTRATION_NUMBER_FIELD_NUMBER: _ClassVar[int]
    VAT_IDENTIFICATION_NUMBER_FIELD_NUMBER: _ClassVar[int]
    VARIABLE_SYMBOL_FIELD_NUMBER: _ClassVar[int]
    PAYMENT_MEMO_REGEX_FIELD_NUMBER: _ClassVar[int]
    IS_VAT_PAYER_FIELD_NUMBER: _ClassVar[int]
    IS_INTERNAL_FIELD_NUMBER: _ClassVar[int]
    registrar_handle: _registrar_common_types_pb2.RegistrarHandle
    name: str
    organization: str
    place: _common_types_pb2.PlaceAddress
    telephone: _common_types_pb2.PhoneNumber
    fax: _common_types_pb2.PhoneNumber
    emails: _containers.RepeatedCompositeFieldContainer[_common_types_pb2.EmailAddress]
    url: _common_types_pb2.Url
    is_system_registrar: bool
    company_registration_number: _common_types_pb2.CompanyRegistrationNumber
    vat_identification_number: _common_types_pb2.VatIdentificationNumber
    variable_symbol: str
    payment_memo_regex: str
    is_vat_payer: bool
    is_internal: bool
    def __init__(self, registrar_handle: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., name: _Optional[str] = ..., organization: _Optional[str] = ..., place: _Optional[_Union[_common_types_pb2.PlaceAddress, _Mapping]] = ..., telephone: _Optional[_Union[_common_types_pb2.PhoneNumber, _Mapping]] = ..., fax: _Optional[_Union[_common_types_pb2.PhoneNumber, _Mapping]] = ..., emails: _Optional[_Iterable[_Union[_common_types_pb2.EmailAddress, _Mapping]]] = ..., url: _Optional[_Union[_common_types_pb2.Url, _Mapping]] = ..., is_system_registrar: bool = ..., company_registration_number: _Optional[_Union[_common_types_pb2.CompanyRegistrationNumber, _Mapping]] = ..., vat_identification_number: _Optional[_Union[_common_types_pb2.VatIdentificationNumber, _Mapping]] = ..., variable_symbol: _Optional[str] = ..., payment_memo_regex: _Optional[str] = ..., is_vat_payer: bool = ..., is_internal: bool = ...) -> None: ...

class CreateRegistrarReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("registrar_handle",)
        REGISTRAR_HANDLE_FIELD_NUMBER: _ClassVar[int]
        registrar_handle: _registrar_common_types_pb2.RegistrarHandle
        def __init__(self, registrar_handle: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("registrar_already_exists", "invalid_data")
        class RegistrarAlreadyExists(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidData(_message.Message):
            __slots__ = ("fields",)
            FIELDS_FIELD_NUMBER: _ClassVar[int]
            fields: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...
        REGISTRAR_ALREADY_EXISTS_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        registrar_already_exists: CreateRegistrarReply.Exception.RegistrarAlreadyExists
        invalid_data: CreateRegistrarReply.Exception.InvalidData
        def __init__(self, registrar_already_exists: _Optional[_Union[CreateRegistrarReply.Exception.RegistrarAlreadyExists, _Mapping]] = ..., invalid_data: _Optional[_Union[CreateRegistrarReply.Exception.InvalidData, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: CreateRegistrarReply.Data
    exception: CreateRegistrarReply.Exception
    def __init__(self, data: _Optional[_Union[CreateRegistrarReply.Data, _Mapping]] = ..., exception: _Optional[_Union[CreateRegistrarReply.Exception, _Mapping]] = ...) -> None: ...

class SetEmailAddresses(_message.Message):
    __slots__ = ("values",)
    VALUES_FIELD_NUMBER: _ClassVar[int]
    values: _containers.RepeatedCompositeFieldContainer[_common_types_pb2.EmailAddress]
    def __init__(self, values: _Optional[_Iterable[_Union[_common_types_pb2.EmailAddress, _Mapping]]] = ...) -> None: ...

class UpdateRegistrarRequest(_message.Message):
    __slots__ = ("registrar_handle", "set_name", "set_organization", "set_place", "set_telephone", "set_fax", "set_emails", "set_url", "set_is_system_registrar", "set_company_registration_number", "set_vat_identification_number", "set_variable_symbol", "set_payment_memo_regex", "set_is_vat_payer", "set_is_internal", "set_registrar_handle")
    REGISTRAR_HANDLE_FIELD_NUMBER: _ClassVar[int]
    SET_NAME_FIELD_NUMBER: _ClassVar[int]
    SET_ORGANIZATION_FIELD_NUMBER: _ClassVar[int]
    SET_PLACE_FIELD_NUMBER: _ClassVar[int]
    SET_TELEPHONE_FIELD_NUMBER: _ClassVar[int]
    SET_FAX_FIELD_NUMBER: _ClassVar[int]
    SET_EMAILS_FIELD_NUMBER: _ClassVar[int]
    SET_URL_FIELD_NUMBER: _ClassVar[int]
    SET_IS_SYSTEM_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
    SET_COMPANY_REGISTRATION_NUMBER_FIELD_NUMBER: _ClassVar[int]
    SET_VAT_IDENTIFICATION_NUMBER_FIELD_NUMBER: _ClassVar[int]
    SET_VARIABLE_SYMBOL_FIELD_NUMBER: _ClassVar[int]
    SET_PAYMENT_MEMO_REGEX_FIELD_NUMBER: _ClassVar[int]
    SET_IS_VAT_PAYER_FIELD_NUMBER: _ClassVar[int]
    SET_IS_INTERNAL_FIELD_NUMBER: _ClassVar[int]
    SET_REGISTRAR_HANDLE_FIELD_NUMBER: _ClassVar[int]
    registrar_handle: _registrar_common_types_pb2.RegistrarHandle
    set_name: str
    set_organization: str
    set_place: _common_types_pb2.PlaceAddress
    set_telephone: _common_types_pb2.PhoneNumber
    set_fax: _common_types_pb2.PhoneNumber
    set_emails: SetEmailAddresses
    set_url: _common_types_pb2.Url
    set_is_system_registrar: bool
    set_company_registration_number: _common_types_pb2.CompanyRegistrationNumber
    set_vat_identification_number: _common_types_pb2.VatIdentificationNumber
    set_variable_symbol: str
    set_payment_memo_regex: str
    set_is_vat_payer: bool
    set_is_internal: bool
    set_registrar_handle: _registrar_common_types_pb2.RegistrarHandle
    def __init__(self, registrar_handle: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., set_name: _Optional[str] = ..., set_organization: _Optional[str] = ..., set_place: _Optional[_Union[_common_types_pb2.PlaceAddress, _Mapping]] = ..., set_telephone: _Optional[_Union[_common_types_pb2.PhoneNumber, _Mapping]] = ..., set_fax: _Optional[_Union[_common_types_pb2.PhoneNumber, _Mapping]] = ..., set_emails: _Optional[_Union[SetEmailAddresses, _Mapping]] = ..., set_url: _Optional[_Union[_common_types_pb2.Url, _Mapping]] = ..., set_is_system_registrar: bool = ..., set_company_registration_number: _Optional[_Union[_common_types_pb2.CompanyRegistrationNumber, _Mapping]] = ..., set_vat_identification_number: _Optional[_Union[_common_types_pb2.VatIdentificationNumber, _Mapping]] = ..., set_variable_symbol: _Optional[str] = ..., set_payment_memo_regex: _Optional[str] = ..., set_is_vat_payer: bool = ..., set_is_internal: bool = ..., set_registrar_handle: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ...) -> None: ...

class UpdateRegistrarReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("registrar_handle",)
        REGISTRAR_HANDLE_FIELD_NUMBER: _ClassVar[int]
        registrar_handle: _registrar_common_types_pb2.RegistrarHandle
        def __init__(self, registrar_handle: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("registrar_does_not_exist", "invalid_data")
        class RegistrarDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidData(_message.Message):
            __slots__ = ("fields",)
            FIELDS_FIELD_NUMBER: _ClassVar[int]
            fields: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...
        REGISTRAR_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        registrar_does_not_exist: UpdateRegistrarReply.Exception.RegistrarDoesNotExist
        invalid_data: UpdateRegistrarReply.Exception.InvalidData
        def __init__(self, registrar_does_not_exist: _Optional[_Union[UpdateRegistrarReply.Exception.RegistrarDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[UpdateRegistrarReply.Exception.InvalidData, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: UpdateRegistrarReply.Data
    exception: UpdateRegistrarReply.Exception
    def __init__(self, data: _Optional[_Union[UpdateRegistrarReply.Data, _Mapping]] = ..., exception: _Optional[_Union[UpdateRegistrarReply.Exception, _Mapping]] = ...) -> None: ...

class RegistrarZoneAccess(_message.Message):
    __slots__ = ("registrar_handle", "zone", "valid_from", "valid_to")
    REGISTRAR_HANDLE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    VALID_FROM_FIELD_NUMBER: _ClassVar[int]
    VALID_TO_FIELD_NUMBER: _ClassVar[int]
    registrar_handle: _registrar_common_types_pb2.RegistrarHandle
    zone: str
    valid_from: _timestamp_pb2.Timestamp
    valid_to: _timestamp_pb2.Timestamp
    def __init__(self, registrar_handle: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., zone: _Optional[str] = ..., valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class AddRegistrarZoneAccessRequest(_message.Message):
    __slots__ = ("registrar_handle", "zone", "valid_from", "valid_to")
    REGISTRAR_HANDLE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    VALID_FROM_FIELD_NUMBER: _ClassVar[int]
    VALID_TO_FIELD_NUMBER: _ClassVar[int]
    registrar_handle: _registrar_common_types_pb2.RegistrarHandle
    zone: str
    valid_from: _timestamp_pb2.Timestamp
    valid_to: _timestamp_pb2.Timestamp
    def __init__(self, registrar_handle: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., zone: _Optional[str] = ..., valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class AddRegistrarZoneAccessReply(_message.Message):
    __slots__ = ("data", "exception")
    class Exception(_message.Message):
        __slots__ = ("registrar_does_not_exist", "zone_does_not_exist", "invalid_data")
        class RegistrarDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class ZoneDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidData(_message.Message):
            __slots__ = ("fields",)
            FIELDS_FIELD_NUMBER: _ClassVar[int]
            fields: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...
        REGISTRAR_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        ZONE_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        registrar_does_not_exist: AddRegistrarZoneAccessReply.Exception.RegistrarDoesNotExist
        zone_does_not_exist: AddRegistrarZoneAccessReply.Exception.ZoneDoesNotExist
        invalid_data: AddRegistrarZoneAccessReply.Exception.InvalidData
        def __init__(self, registrar_does_not_exist: _Optional[_Union[AddRegistrarZoneAccessReply.Exception.RegistrarDoesNotExist, _Mapping]] = ..., zone_does_not_exist: _Optional[_Union[AddRegistrarZoneAccessReply.Exception.ZoneDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[AddRegistrarZoneAccessReply.Exception.InvalidData, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: RegistrarZoneAccess
    exception: AddRegistrarZoneAccessReply.Exception
    def __init__(self, data: _Optional[_Union[RegistrarZoneAccess, _Mapping]] = ..., exception: _Optional[_Union[AddRegistrarZoneAccessReply.Exception, _Mapping]] = ...) -> None: ...

class UpdateRegistrarZoneAccessRequest(_message.Message):
    __slots__ = ("registrar_handle", "zone", "valid_from", "set_valid_from", "set_valid_to")
    REGISTRAR_HANDLE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    VALID_FROM_FIELD_NUMBER: _ClassVar[int]
    SET_VALID_FROM_FIELD_NUMBER: _ClassVar[int]
    SET_VALID_TO_FIELD_NUMBER: _ClassVar[int]
    registrar_handle: _registrar_common_types_pb2.RegistrarHandle
    zone: str
    valid_from: _timestamp_pb2.Timestamp
    set_valid_from: _timestamp_pb2.Timestamp
    set_valid_to: _timestamp_pb2.Timestamp
    def __init__(self, registrar_handle: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., zone: _Optional[str] = ..., valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., set_valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., set_valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class UpdateRegistrarZoneAccessReply(_message.Message):
    __slots__ = ("data", "exception")
    class Exception(_message.Message):
        __slots__ = ("registrar_zone_access_does_not_exist", "history_change_prohibited", "invalid_data")
        class RegistrarZoneAccessDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class HistoryChangeProhibited(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidData(_message.Message):
            __slots__ = ("fields",)
            FIELDS_FIELD_NUMBER: _ClassVar[int]
            fields: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...
        REGISTRAR_ZONE_ACCESS_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        HISTORY_CHANGE_PROHIBITED_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        registrar_zone_access_does_not_exist: UpdateRegistrarZoneAccessReply.Exception.RegistrarZoneAccessDoesNotExist
        history_change_prohibited: UpdateRegistrarZoneAccessReply.Exception.HistoryChangeProhibited
        invalid_data: UpdateRegistrarZoneAccessReply.Exception.InvalidData
        def __init__(self, registrar_zone_access_does_not_exist: _Optional[_Union[UpdateRegistrarZoneAccessReply.Exception.RegistrarZoneAccessDoesNotExist, _Mapping]] = ..., history_change_prohibited: _Optional[_Union[UpdateRegistrarZoneAccessReply.Exception.HistoryChangeProhibited, _Mapping]] = ..., invalid_data: _Optional[_Union[UpdateRegistrarZoneAccessReply.Exception.InvalidData, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: RegistrarZoneAccess
    exception: UpdateRegistrarZoneAccessReply.Exception
    def __init__(self, data: _Optional[_Union[RegistrarZoneAccess, _Mapping]] = ..., exception: _Optional[_Union[UpdateRegistrarZoneAccessReply.Exception, _Mapping]] = ...) -> None: ...

class DeleteRegistrarZoneAccessRequest(_message.Message):
    __slots__ = ("registrar_handle", "zone", "valid_from")
    REGISTRAR_HANDLE_FIELD_NUMBER: _ClassVar[int]
    ZONE_FIELD_NUMBER: _ClassVar[int]
    VALID_FROM_FIELD_NUMBER: _ClassVar[int]
    registrar_handle: _registrar_common_types_pb2.RegistrarHandle
    zone: str
    valid_from: _timestamp_pb2.Timestamp
    def __init__(self, registrar_handle: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., zone: _Optional[str] = ..., valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class DeleteRegistrarZoneAccessReply(_message.Message):
    __slots__ = ("exception",)
    class Exception(_message.Message):
        __slots__ = ("registrar_zone_access_does_not_exist", "history_change_prohibited", "invalid_data")
        class RegistrarZoneAccessDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class HistoryChangeProhibited(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidData(_message.Message):
            __slots__ = ("fields",)
            FIELDS_FIELD_NUMBER: _ClassVar[int]
            fields: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...
        REGISTRAR_ZONE_ACCESS_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        HISTORY_CHANGE_PROHIBITED_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        registrar_zone_access_does_not_exist: DeleteRegistrarZoneAccessReply.Exception.RegistrarZoneAccessDoesNotExist
        history_change_prohibited: DeleteRegistrarZoneAccessReply.Exception.HistoryChangeProhibited
        invalid_data: DeleteRegistrarZoneAccessReply.Exception.InvalidData
        def __init__(self, registrar_zone_access_does_not_exist: _Optional[_Union[DeleteRegistrarZoneAccessReply.Exception.RegistrarZoneAccessDoesNotExist, _Mapping]] = ..., history_change_prohibited: _Optional[_Union[DeleteRegistrarZoneAccessReply.Exception.HistoryChangeProhibited, _Mapping]] = ..., invalid_data: _Optional[_Union[DeleteRegistrarZoneAccessReply.Exception.InvalidData, _Mapping]] = ...) -> None: ...
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    exception: DeleteRegistrarZoneAccessReply.Exception
    def __init__(self, exception: _Optional[_Union[DeleteRegistrarZoneAccessReply.Exception, _Mapping]] = ...) -> None: ...

class AddRegistrarEppCredentialsRequest(_message.Message):
    __slots__ = ("registrar_handle", "certificate", "password", "template_credentials_id")
    REGISTRAR_HANDLE_FIELD_NUMBER: _ClassVar[int]
    CERTIFICATE_FIELD_NUMBER: _ClassVar[int]
    PASSWORD_FIELD_NUMBER: _ClassVar[int]
    TEMPLATE_CREDENTIALS_ID_FIELD_NUMBER: _ClassVar[int]
    registrar_handle: _registrar_common_types_pb2.RegistrarHandle
    certificate: _registrar_common_types_pb2.SslCertificate
    password: str
    template_credentials_id: _registrar_common_types_pb2.RegistrarEppCredentialsId
    def __init__(self, registrar_handle: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., certificate: _Optional[_Union[_registrar_common_types_pb2.SslCertificate, _Mapping]] = ..., password: _Optional[str] = ..., template_credentials_id: _Optional[_Union[_registrar_common_types_pb2.RegistrarEppCredentialsId, _Mapping]] = ...) -> None: ...

class AddRegistrarEppCredentialsReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("credentials_id",)
        CREDENTIALS_ID_FIELD_NUMBER: _ClassVar[int]
        credentials_id: _registrar_common_types_pb2.RegistrarEppCredentialsId
        def __init__(self, credentials_id: _Optional[_Union[_registrar_common_types_pb2.RegistrarEppCredentialsId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("registrar_does_not_exist", "registrar_epp_credentials_does_not_exist", "invalid_data")
        class RegistrarDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class RegistrarEppCredentialsDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidData(_message.Message):
            __slots__ = ("fields",)
            FIELDS_FIELD_NUMBER: _ClassVar[int]
            fields: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...
        REGISTRAR_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        REGISTRAR_EPP_CREDENTIALS_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        registrar_does_not_exist: AddRegistrarEppCredentialsReply.Exception.RegistrarDoesNotExist
        registrar_epp_credentials_does_not_exist: AddRegistrarEppCredentialsReply.Exception.RegistrarEppCredentialsDoesNotExist
        invalid_data: AddRegistrarEppCredentialsReply.Exception.InvalidData
        def __init__(self, registrar_does_not_exist: _Optional[_Union[AddRegistrarEppCredentialsReply.Exception.RegistrarDoesNotExist, _Mapping]] = ..., registrar_epp_credentials_does_not_exist: _Optional[_Union[AddRegistrarEppCredentialsReply.Exception.RegistrarEppCredentialsDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[AddRegistrarEppCredentialsReply.Exception.InvalidData, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: AddRegistrarEppCredentialsReply.Data
    exception: AddRegistrarEppCredentialsReply.Exception
    def __init__(self, data: _Optional[_Union[AddRegistrarEppCredentialsReply.Data, _Mapping]] = ..., exception: _Optional[_Union[AddRegistrarEppCredentialsReply.Exception, _Mapping]] = ...) -> None: ...

class UpdateRegistrarEppCredentialsRequest(_message.Message):
    __slots__ = ("credentials_id", "password")
    CREDENTIALS_ID_FIELD_NUMBER: _ClassVar[int]
    PASSWORD_FIELD_NUMBER: _ClassVar[int]
    credentials_id: _registrar_common_types_pb2.RegistrarEppCredentialsId
    password: str
    def __init__(self, credentials_id: _Optional[_Union[_registrar_common_types_pb2.RegistrarEppCredentialsId, _Mapping]] = ..., password: _Optional[str] = ...) -> None: ...

class UpdateRegistrarEppCredentialsReply(_message.Message):
    __slots__ = ("exception",)
    class Exception(_message.Message):
        __slots__ = ("registrar_epp_credentials_does_not_exist", "invalid_data")
        class RegistrarEppCredentialsDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidData(_message.Message):
            __slots__ = ("fields",)
            FIELDS_FIELD_NUMBER: _ClassVar[int]
            fields: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...
        REGISTRAR_EPP_CREDENTIALS_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        registrar_epp_credentials_does_not_exist: UpdateRegistrarEppCredentialsReply.Exception.RegistrarEppCredentialsDoesNotExist
        invalid_data: UpdateRegistrarEppCredentialsReply.Exception.InvalidData
        def __init__(self, registrar_epp_credentials_does_not_exist: _Optional[_Union[UpdateRegistrarEppCredentialsReply.Exception.RegistrarEppCredentialsDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[UpdateRegistrarEppCredentialsReply.Exception.InvalidData, _Mapping]] = ...) -> None: ...
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    exception: UpdateRegistrarEppCredentialsReply.Exception
    def __init__(self, exception: _Optional[_Union[UpdateRegistrarEppCredentialsReply.Exception, _Mapping]] = ...) -> None: ...

class DeleteRegistrarEppCredentialsRequest(_message.Message):
    __slots__ = ("credentials_id",)
    CREDENTIALS_ID_FIELD_NUMBER: _ClassVar[int]
    credentials_id: _registrar_common_types_pb2.RegistrarEppCredentialsId
    def __init__(self, credentials_id: _Optional[_Union[_registrar_common_types_pb2.RegistrarEppCredentialsId, _Mapping]] = ...) -> None: ...

class DeleteRegistrarEppCredentialsReply(_message.Message):
    __slots__ = ("exception",)
    class Exception(_message.Message):
        __slots__ = ("registrar_epp_credentials_does_not_exist", "invalid_data")
        class RegistrarEppCredentialsDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidData(_message.Message):
            __slots__ = ("fields",)
            FIELDS_FIELD_NUMBER: _ClassVar[int]
            fields: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...
        REGISTRAR_EPP_CREDENTIALS_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        registrar_epp_credentials_does_not_exist: DeleteRegistrarEppCredentialsReply.Exception.RegistrarEppCredentialsDoesNotExist
        invalid_data: DeleteRegistrarEppCredentialsReply.Exception.InvalidData
        def __init__(self, registrar_epp_credentials_does_not_exist: _Optional[_Union[DeleteRegistrarEppCredentialsReply.Exception.RegistrarEppCredentialsDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[DeleteRegistrarEppCredentialsReply.Exception.InvalidData, _Mapping]] = ...) -> None: ...
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    exception: DeleteRegistrarEppCredentialsReply.Exception
    def __init__(self, exception: _Optional[_Union[DeleteRegistrarEppCredentialsReply.Exception, _Mapping]] = ...) -> None: ...

class AddRegistrarGroupMembershipRequest(_message.Message):
    __slots__ = ("registrar_handle", "group")
    REGISTRAR_HANDLE_FIELD_NUMBER: _ClassVar[int]
    GROUP_FIELD_NUMBER: _ClassVar[int]
    registrar_handle: _registrar_common_types_pb2.RegistrarHandle
    group: str
    def __init__(self, registrar_handle: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., group: _Optional[str] = ...) -> None: ...

class AddRegistrarGroupMembershipReply(_message.Message):
    __slots__ = ("data", "exception")
    class Exception(_message.Message):
        __slots__ = ("registrar_does_not_exist", "group_does_not_exist")
        class RegistrarDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class GroupDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        REGISTRAR_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        GROUP_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        registrar_does_not_exist: AddRegistrarGroupMembershipReply.Exception.RegistrarDoesNotExist
        group_does_not_exist: AddRegistrarGroupMembershipReply.Exception.GroupDoesNotExist
        def __init__(self, registrar_does_not_exist: _Optional[_Union[AddRegistrarGroupMembershipReply.Exception.RegistrarDoesNotExist, _Mapping]] = ..., group_does_not_exist: _Optional[_Union[AddRegistrarGroupMembershipReply.Exception.GroupDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: _registrar_common_types_pb2.RegistrarGroupsMembership
    exception: AddRegistrarGroupMembershipReply.Exception
    def __init__(self, data: _Optional[_Union[_registrar_common_types_pb2.RegistrarGroupsMembership, _Mapping]] = ..., exception: _Optional[_Union[AddRegistrarGroupMembershipReply.Exception, _Mapping]] = ...) -> None: ...

class DeleteRegistrarGroupMembershipRequest(_message.Message):
    __slots__ = ("registrar_handle", "group")
    REGISTRAR_HANDLE_FIELD_NUMBER: _ClassVar[int]
    GROUP_FIELD_NUMBER: _ClassVar[int]
    registrar_handle: _registrar_common_types_pb2.RegistrarHandle
    group: str
    def __init__(self, registrar_handle: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., group: _Optional[str] = ...) -> None: ...

class DeleteRegistrarGroupMembershipReply(_message.Message):
    __slots__ = ("data", "exception")
    class Exception(_message.Message):
        __slots__ = ("registrar_does_not_exist", "group_does_not_exist")
        class RegistrarDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class GroupDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        REGISTRAR_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        GROUP_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        registrar_does_not_exist: DeleteRegistrarGroupMembershipReply.Exception.RegistrarDoesNotExist
        group_does_not_exist: DeleteRegistrarGroupMembershipReply.Exception.GroupDoesNotExist
        def __init__(self, registrar_does_not_exist: _Optional[_Union[DeleteRegistrarGroupMembershipReply.Exception.RegistrarDoesNotExist, _Mapping]] = ..., group_does_not_exist: _Optional[_Union[DeleteRegistrarGroupMembershipReply.Exception.GroupDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: _registrar_common_types_pb2.RegistrarGroupsMembership
    exception: DeleteRegistrarGroupMembershipReply.Exception
    def __init__(self, data: _Optional[_Union[_registrar_common_types_pb2.RegistrarGroupsMembership, _Mapping]] = ..., exception: _Optional[_Union[DeleteRegistrarGroupMembershipReply.Exception, _Mapping]] = ...) -> None: ...

class AddRegistrarCertificationRequest(_message.Message):
    __slots__ = ("registrar_handle", "valid_from", "valid_to", "classification", "file_id")
    REGISTRAR_HANDLE_FIELD_NUMBER: _ClassVar[int]
    VALID_FROM_FIELD_NUMBER: _ClassVar[int]
    VALID_TO_FIELD_NUMBER: _ClassVar[int]
    CLASSIFICATION_FIELD_NUMBER: _ClassVar[int]
    FILE_ID_FIELD_NUMBER: _ClassVar[int]
    registrar_handle: _registrar_common_types_pb2.RegistrarHandle
    valid_from: _timestamp_pb2.Timestamp
    valid_to: _timestamp_pb2.Timestamp
    classification: int
    file_id: _common_types_pb2.FileId
    def __init__(self, registrar_handle: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., classification: _Optional[int] = ..., file_id: _Optional[_Union[_common_types_pb2.FileId, _Mapping]] = ...) -> None: ...

class AddRegistrarCertificationReply(_message.Message):
    __slots__ = ("data", "exception")
    class Exception(_message.Message):
        __slots__ = ("registrar_does_not_exist", "invalid_data")
        class RegistrarDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidData(_message.Message):
            __slots__ = ("fields",)
            FIELDS_FIELD_NUMBER: _ClassVar[int]
            fields: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...
        REGISTRAR_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        registrar_does_not_exist: AddRegistrarCertificationReply.Exception.RegistrarDoesNotExist
        invalid_data: AddRegistrarCertificationReply.Exception.InvalidData
        def __init__(self, registrar_does_not_exist: _Optional[_Union[AddRegistrarCertificationReply.Exception.RegistrarDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[AddRegistrarCertificationReply.Exception.InvalidData, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: _registrar_common_types_pb2.RegistrarCertification
    exception: AddRegistrarCertificationReply.Exception
    def __init__(self, data: _Optional[_Union[_registrar_common_types_pb2.RegistrarCertification, _Mapping]] = ..., exception: _Optional[_Union[AddRegistrarCertificationReply.Exception, _Mapping]] = ...) -> None: ...

class UpdateRegistrarCertificationRequest(_message.Message):
    __slots__ = ("certification_id", "set_valid_to", "set_classification", "set_file_id")
    CERTIFICATION_ID_FIELD_NUMBER: _ClassVar[int]
    SET_VALID_TO_FIELD_NUMBER: _ClassVar[int]
    SET_CLASSIFICATION_FIELD_NUMBER: _ClassVar[int]
    SET_FILE_ID_FIELD_NUMBER: _ClassVar[int]
    certification_id: _registrar_common_types_pb2.RegistrarCertificationId
    set_valid_to: _timestamp_pb2.Timestamp
    set_classification: int
    set_file_id: _common_types_pb2.FileId
    def __init__(self, certification_id: _Optional[_Union[_registrar_common_types_pb2.RegistrarCertificationId, _Mapping]] = ..., set_valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., set_classification: _Optional[int] = ..., set_file_id: _Optional[_Union[_common_types_pb2.FileId, _Mapping]] = ...) -> None: ...

class UpdateRegistrarCertificationReply(_message.Message):
    __slots__ = ("data", "exception")
    class Exception(_message.Message):
        __slots__ = ("registrar_certification_does_not_exist", "invalid_data")
        class RegistrarCertificationDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidData(_message.Message):
            __slots__ = ("fields",)
            FIELDS_FIELD_NUMBER: _ClassVar[int]
            fields: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...
        REGISTRAR_CERTIFICATION_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        registrar_certification_does_not_exist: UpdateRegistrarCertificationReply.Exception.RegistrarCertificationDoesNotExist
        invalid_data: UpdateRegistrarCertificationReply.Exception.InvalidData
        def __init__(self, registrar_certification_does_not_exist: _Optional[_Union[UpdateRegistrarCertificationReply.Exception.RegistrarCertificationDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[UpdateRegistrarCertificationReply.Exception.InvalidData, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: _registrar_common_types_pb2.RegistrarCertification
    exception: UpdateRegistrarCertificationReply.Exception
    def __init__(self, data: _Optional[_Union[_registrar_common_types_pb2.RegistrarCertification, _Mapping]] = ..., exception: _Optional[_Union[UpdateRegistrarCertificationReply.Exception, _Mapping]] = ...) -> None: ...

class DeleteRegistrarCertificationRequest(_message.Message):
    __slots__ = ("certification_id",)
    CERTIFICATION_ID_FIELD_NUMBER: _ClassVar[int]
    certification_id: _registrar_common_types_pb2.RegistrarCertificationId
    def __init__(self, certification_id: _Optional[_Union[_registrar_common_types_pb2.RegistrarCertificationId, _Mapping]] = ...) -> None: ...

class DeleteRegistrarCertificationReply(_message.Message):
    __slots__ = ("exception",)
    class Exception(_message.Message):
        __slots__ = ("registrar_certification_does_not_exist", "invalid_data")
        class RegistrarCertificationDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidData(_message.Message):
            __slots__ = ("fields",)
            FIELDS_FIELD_NUMBER: _ClassVar[int]
            fields: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...
        REGISTRAR_CERTIFICATION_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        registrar_certification_does_not_exist: DeleteRegistrarCertificationReply.Exception.RegistrarCertificationDoesNotExist
        invalid_data: DeleteRegistrarCertificationReply.Exception.InvalidData
        def __init__(self, registrar_certification_does_not_exist: _Optional[_Union[DeleteRegistrarCertificationReply.Exception.RegistrarCertificationDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[DeleteRegistrarCertificationReply.Exception.InvalidData, _Mapping]] = ...) -> None: ...
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    exception: DeleteRegistrarCertificationReply.Exception
    def __init__(self, exception: _Optional[_Union[DeleteRegistrarCertificationReply.Exception, _Mapping]] = ...) -> None: ...
